// Autogenerated from Pigeon (v1.0.12), do not edit directly.
// See also: https://pub.dev/packages/pigeon

package com.example.flutter_locker;

import io.flutter.plugin.common.BasicMessageChannel;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MessageCodec;
import io.flutter.plugin.common.StandardMessageCodec;
import java.io.ByteArrayOutputStream;
import java.nio.ByteBuffer;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;

/** Generated class from Pigeon. */
@SuppressWarnings({"unused", "unchecked", "CodeBlock2Expr", "RedundantSuppression"})
public class Pigeon {

  public enum LockerError {
    secretNotFound(0),
    authenticationCanceled(1),
    authenticationFailed(2),
    unknown(3);

    private int index;
    private LockerError(final int index) {
      this.index = index;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static class AndroidPrompt {
    private String title;
    public String getTitle() { return title; }
    public void setTitle(String setterArg) { this.title = setterArg; }

    private String cancelLabel;
    public String getCancelLabel() { return cancelLabel; }
    public void setCancelLabel(String setterArg) { this.cancelLabel = setterArg; }

    private String description;
    public String getDescription() { return description; }
    public void setDescription(String setterArg) { this.description = setterArg; }

    Map<String, Object> toMap() {
      Map<String, Object> toMapResult = new HashMap<>();
      toMapResult.put("title", title);
      toMapResult.put("cancelLabel", cancelLabel);
      toMapResult.put("description", description);
      return toMapResult;
    }
    static AndroidPrompt fromMap(Map<String, Object> map) {
      AndroidPrompt fromMapResult = new AndroidPrompt();
      Object title = map.get("title");
      fromMapResult.title = (String)title;
      Object cancelLabel = map.get("cancelLabel");
      fromMapResult.cancelLabel = (String)cancelLabel;
      Object description = map.get("description");
      fromMapResult.description = (String)description;
      return fromMapResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static class SaveSecretRequest {
    private String key;
    public String getKey() { return key; }
    public void setKey(String setterArg) { this.key = setterArg; }

    private String secret;
    public String getSecret() { return secret; }
    public void setSecret(String setterArg) { this.secret = setterArg; }

    private AndroidPrompt androidPrompt;
    public AndroidPrompt getAndroidPrompt() { return androidPrompt; }
    public void setAndroidPrompt(AndroidPrompt setterArg) { this.androidPrompt = setterArg; }

    Map<String, Object> toMap() {
      Map<String, Object> toMapResult = new HashMap<>();
      toMapResult.put("key", key);
      toMapResult.put("secret", secret);
      toMapResult.put("androidPrompt", (androidPrompt == null) ? null : androidPrompt.toMap());
      return toMapResult;
    }
    static SaveSecretRequest fromMap(Map<String, Object> map) {
      SaveSecretRequest fromMapResult = new SaveSecretRequest();
      Object key = map.get("key");
      fromMapResult.key = (String)key;
      Object secret = map.get("secret");
      fromMapResult.secret = (String)secret;
      Object androidPrompt = map.get("androidPrompt");
      fromMapResult.androidPrompt = AndroidPrompt.fromMap((Map)androidPrompt);
      return fromMapResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static class RetrieveSecretRequest {
    private String key;
    public String getKey() { return key; }
    public void setKey(String setterArg) { this.key = setterArg; }

    private AndroidPrompt androidPrompt;
    public AndroidPrompt getAndroidPrompt() { return androidPrompt; }
    public void setAndroidPrompt(AndroidPrompt setterArg) { this.androidPrompt = setterArg; }

    private IOsPrompt iOsPrompt;
    public IOsPrompt getIOsPrompt() { return iOsPrompt; }
    public void setIOsPrompt(IOsPrompt setterArg) { this.iOsPrompt = setterArg; }

    Map<String, Object> toMap() {
      Map<String, Object> toMapResult = new HashMap<>();
      toMapResult.put("key", key);
      toMapResult.put("androidPrompt", (androidPrompt == null) ? null : androidPrompt.toMap());
      toMapResult.put("iOsPrompt", (iOsPrompt == null) ? null : iOsPrompt.toMap());
      return toMapResult;
    }
    static RetrieveSecretRequest fromMap(Map<String, Object> map) {
      RetrieveSecretRequest fromMapResult = new RetrieveSecretRequest();
      Object key = map.get("key");
      fromMapResult.key = (String)key;
      Object androidPrompt = map.get("androidPrompt");
      fromMapResult.androidPrompt = AndroidPrompt.fromMap((Map)androidPrompt);
      Object iOsPrompt = map.get("iOsPrompt");
      fromMapResult.iOsPrompt = IOsPrompt.fromMap((Map)iOsPrompt);
      return fromMapResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static class RetrieveSecretResponse {
    private String secret;
    public String getSecret() { return secret; }
    public void setSecret(String setterArg) { this.secret = setterArg; }

    private LockerError error;
    public LockerError getError() { return error; }
    public void setError(LockerError setterArg) { this.error = setterArg; }

    Map<String, Object> toMap() {
      Map<String, Object> toMapResult = new HashMap<>();
      toMapResult.put("secret", secret);
      toMapResult.put("error", error == null ? null : error.index);
      return toMapResult;
    }
    static RetrieveSecretResponse fromMap(Map<String, Object> map) {
      RetrieveSecretResponse fromMapResult = new RetrieveSecretResponse();
      Object secret = map.get("secret");
      fromMapResult.secret = (String)secret;
      Object error = map.get("error");
      fromMapResult.error = error == null ? null : LockerError.values()[(int)error];
      return fromMapResult;
    }
  }

  /** Generated class from Pigeon that represents data sent in messages. */
  public static class IOsPrompt {
    private String touchIdText;
    public String getTouchIdText() { return touchIdText; }
    public void setTouchIdText(String setterArg) { this.touchIdText = setterArg; }

    Map<String, Object> toMap() {
      Map<String, Object> toMapResult = new HashMap<>();
      toMapResult.put("touchIdText", touchIdText);
      return toMapResult;
    }
    static IOsPrompt fromMap(Map<String, Object> map) {
      IOsPrompt fromMapResult = new IOsPrompt();
      Object touchIdText = map.get("touchIdText");
      fromMapResult.touchIdText = (String)touchIdText;
      return fromMapResult;
    }
  }
  private static class ToNativeApiCodec extends StandardMessageCodec {
    public static final ToNativeApiCodec INSTANCE = new ToNativeApiCodec();
    private ToNativeApiCodec() {}
    @Override
    protected Object readValueOfType(byte type, ByteBuffer buffer) {
      switch (type) {
        case (byte)128:         
          return AndroidPrompt.fromMap((Map<String, Object>) readValue(buffer));
        
        case (byte)129:         
          return IOsPrompt.fromMap((Map<String, Object>) readValue(buffer));
        
        case (byte)130:         
          return RetrieveSecretRequest.fromMap((Map<String, Object>) readValue(buffer));
        
        case (byte)131:         
          return SaveSecretRequest.fromMap((Map<String, Object>) readValue(buffer));
        
        default:        
          return super.readValueOfType(type, buffer);
        
      }
    }
    @Override
    protected void writeValue(ByteArrayOutputStream stream, Object value)     {
      if (value instanceof AndroidPrompt) {
        stream.write(128);
        writeValue(stream, ((AndroidPrompt) value).toMap());
      } else 
      if (value instanceof IOsPrompt) {
        stream.write(129);
        writeValue(stream, ((IOsPrompt) value).toMap());
      } else 
      if (value instanceof RetrieveSecretRequest) {
        stream.write(130);
        writeValue(stream, ((RetrieveSecretRequest) value).toMap());
      } else 
      if (value instanceof SaveSecretRequest) {
        stream.write(131);
        writeValue(stream, ((SaveSecretRequest) value).toMap());
      } else 
{
        super.writeValue(stream, value);
      }
    }
  }

  /** Generated interface from Pigeon that represents a handler of messages from Flutter.*/
  public interface ToNativeApi {
    void canAuthenticate();
    void saveSecret(SaveSecretRequest request);
    void retrieveSecret(RetrieveSecretRequest request);
    void deleteSecret(String key);

    /** The codec used by ToNativeApi. */
    static MessageCodec<Object> getCodec() {
      return ToNativeApiCodec.INSTANCE;
    }

    /** Sets up an instance of `ToNativeApi` to handle messages through the `binaryMessenger`. */
    static void setup(BinaryMessenger binaryMessenger, ToNativeApi api) {
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToNativeApi.canAuthenticate", getCodec());
        if (api != null) {
          channel.setMessageHandler((message, reply) -> {
            Map<String, Object> wrapped = new HashMap<>();
            try {
              api.canAuthenticate();
              wrapped.put("result", null);
            }
            catch (Error | RuntimeException exception) {
              wrapped.put("error", wrapError(exception));
            }
            reply.reply(wrapped);
          });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToNativeApi.saveSecret", getCodec());
        if (api != null) {
          channel.setMessageHandler((message, reply) -> {
            Map<String, Object> wrapped = new HashMap<>();
            try {
              ArrayList<Object> args = (ArrayList<Object>)message;
              SaveSecretRequest requestArg = (SaveSecretRequest)args.get(0);
              if (requestArg == null) {
                throw new NullPointerException("requestArg unexpectedly null.");
              }
              api.saveSecret(requestArg);
              wrapped.put("result", null);
            }
            catch (Error | RuntimeException exception) {
              wrapped.put("error", wrapError(exception));
            }
            reply.reply(wrapped);
          });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToNativeApi.retrieveSecret", getCodec());
        if (api != null) {
          channel.setMessageHandler((message, reply) -> {
            Map<String, Object> wrapped = new HashMap<>();
            try {
              ArrayList<Object> args = (ArrayList<Object>)message;
              RetrieveSecretRequest requestArg = (RetrieveSecretRequest)args.get(0);
              if (requestArg == null) {
                throw new NullPointerException("requestArg unexpectedly null.");
              }
              api.retrieveSecret(requestArg);
              wrapped.put("result", null);
            }
            catch (Error | RuntimeException exception) {
              wrapped.put("error", wrapError(exception));
            }
            reply.reply(wrapped);
          });
        } else {
          channel.setMessageHandler(null);
        }
      }
      {
        BasicMessageChannel<Object> channel =
            new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToNativeApi.deleteSecret", getCodec());
        if (api != null) {
          channel.setMessageHandler((message, reply) -> {
            Map<String, Object> wrapped = new HashMap<>();
            try {
              ArrayList<Object> args = (ArrayList<Object>)message;
              String keyArg = (String)args.get(0);
              if (keyArg == null) {
                throw new NullPointerException("keyArg unexpectedly null.");
              }
              api.deleteSecret(keyArg);
              wrapped.put("result", null);
            }
            catch (Error | RuntimeException exception) {
              wrapped.put("error", wrapError(exception));
            }
            reply.reply(wrapped);
          });
        } else {
          channel.setMessageHandler(null);
        }
      }
    }
  }
  private static class ToFlutterApiCodec extends StandardMessageCodec {
    public static final ToFlutterApiCodec INSTANCE = new ToFlutterApiCodec();
    private ToFlutterApiCodec() {}
    @Override
    protected Object readValueOfType(byte type, ByteBuffer buffer) {
      switch (type) {
        case (byte)128:         
          return RetrieveSecretResponse.fromMap((Map<String, Object>) readValue(buffer));
        
        default:        
          return super.readValueOfType(type, buffer);
        
      }
    }
    @Override
    protected void writeValue(ByteArrayOutputStream stream, Object value)     {
      if (value instanceof RetrieveSecretResponse) {
        stream.write(128);
        writeValue(stream, ((RetrieveSecretResponse) value).toMap());
      } else 
{
        super.writeValue(stream, value);
      }
    }
  }

  /** Generated class from Pigeon that represents Flutter messages that can be called from Java.*/
  public static class ToFlutterApi {
    private final BinaryMessenger binaryMessenger;
    public ToFlutterApi(BinaryMessenger argBinaryMessenger){
      this.binaryMessenger = argBinaryMessenger;
    }
    public interface Reply<T> {
      void reply(T reply);
    }
    static MessageCodec<Object> getCodec() {
      return ToFlutterApiCodec.INSTANCE;
    }

    public void canAuthenticateResult(Boolean canAuthenticateArg, Reply<Void> callback) {
      BasicMessageChannel<Object> channel =
          new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToFlutterApi.canAuthenticateResult", getCodec());
      channel.send(new ArrayList<Object>(Arrays.asList(canAuthenticateArg)), channelReply -> {
        callback.reply(null);
      });
    }
    public void saveSecretResult(Reply<Void> callback) {
      BasicMessageChannel<Object> channel =
          new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToFlutterApi.saveSecretResult", getCodec());
      channel.send(null, channelReply -> {
        callback.reply(null);
      });
    }
    public void retrieveSecretResult(RetrieveSecretResponse responseArg, Reply<Void> callback) {
      BasicMessageChannel<Object> channel =
          new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToFlutterApi.retrieveSecretResult", getCodec());
      channel.send(new ArrayList<Object>(Arrays.asList(responseArg)), channelReply -> {
        callback.reply(null);
      });
    }
    public void deleteSecretResult(Reply<Void> callback) {
      BasicMessageChannel<Object> channel =
          new BasicMessageChannel<>(binaryMessenger, "dev.flutter.pigeon.ToFlutterApi.deleteSecretResult", getCodec());
      channel.send(null, channelReply -> {
        callback.reply(null);
      });
    }
  }
  private static Map<String, Object> wrapError(Throwable exception) {
    Map<String, Object> errorMap = new HashMap<>();
    errorMap.put("message", exception.toString());
    errorMap.put("code", exception.getClass().getSimpleName());
    errorMap.put("details", null);
    return errorMap;
  }
}
